<ng-container *ngIf="person">
  <h1>{{ person.title !== ' ' ? person.title : 'New Person' }}</h1>

  <mat-accordion [multi]="false">
    <mat-expansion-panel
      hideToggle
      expanded
      class="has-required"
      [class.invalid]="!generalInformationValid"
    >
      <mat-expansion-panel-header>
        <mat-panel-title>
          <mat-icon
            matTooltip="Section contains required fields"
            [color]="generalInformationValid ? 'primary' : 'accent'"
            class="required-info"
          >
            label_important
          </mat-icon>
          <span>General Information</span>
        </mat-panel-title>
        <mat-panel-description></mat-panel-description>
      </mat-expansion-panel-header>

      <ng-container *ngIf="isExisting$ | async; else newPerson">
        <p>You are adding onto an existing person.</p>

        <p>{{ person.title }}</p>
      </ng-container>
      <ng-template #newPerson>
        <p>Add a new person</p>
      </ng-template>
    </mat-expansion-panel>

    <mat-expansion-panel
      hideToggle
      class="has-required"
      [class.invalid]="!(anyRoleSelected$ | async)"
    >
      <mat-expansion-panel-header>
        <mat-panel-title>
          <mat-icon
            matTooltip="Section contains required fields"
            [color]="(anyRoleSelected$ | async) ? 'primary' : 'accent'"
            class="required-info"
          >
            label_important
          </mat-icon>
          <span>Role selection</span>
        </mat-panel-title>
        <mat-panel-description></mat-panel-description>
      </mat-expansion-panel-header>

      <p *ngIf="!(anyRoleSelected$ | async)">You need to select at least one role</p>
      <div class="role-selection">
        <mat-checkbox
          *ngFor="let role of availableRoles"
          [(ngModel)]="role.checked"
          (change)="updateRoles()"
        >
          {{ role.value }}
        </mat-checkbox>
      </div>
    </mat-expansion-panel>

    <mat-expansion-panel hideToggle class="has-required" [class.invalid]="!contactValid">
      <mat-expansion-panel-header>
        <mat-panel-title>
          <mat-icon
            matTooltip="Section contains required fields"
            [color]="contactValid ? 'primary' : 'accent'"
            class="required-info"
          >
            label_important
          </mat-icon>
          <span>Contact</span>
        </mat-panel-title>
        <mat-panel-description></mat-panel-description>
      </mat-expansion-panel-header>

      <ng-container *ngIf="availableContacts$ | async as availableContacts">
        <ng-container *ngIf="selectedContact$ | async as selectedContact">
          <p>
            You can choose an existing contact reference or attach a new one. We've already selected
            the most recent contact for you.
          </p>

          <mat-form-field appearance="fill">
            <mat-label>Existing contact reference</mat-label>
            <mat-select (selectionChange)="selectContact($event)">
              <mat-select-trigger>
                {{ selectedContact.infoString }}
              </mat-select-trigger>
              <mat-option value="empty"> Empty Contact </mat-option>
              <mat-option *ngFor="let contact of availableContacts" [value]="contact._id">
                {{ contact.infoString }}
              </mat-option>
            </mat-select>
          </mat-form-field>
        </ng-container>
      </ng-container>
    </mat-expansion-panel>

    <mat-expansion-panel hideToggle>
      <mat-expansion-panel-header>
        <mat-panel-title>
          <mat-icon matTooltip="Section is optional" color="primary" class="required-info">
            label
          </mat-icon>
          <span>Institutions</span>
          <button mat-icon-button color="primary" (click)="addInstitution($event)">
            <mat-icon>add_circle</mat-icon>
          </button>
        </mat-panel-title>
        <mat-panel-description></mat-panel-description>
      </mat-expansion-panel-header>

      <mat-form-field>
        <mat-label>Search for an existing institution</mat-label>
        <input
          type="text"
          placeholder="Enter the name of an institution"
          matInput
          [formControl]="searchInstitution"
          [matAutocomplete]="instAutocomplete"
        />
        <mat-autocomplete
          #instAutocomplete="matAutocomplete"
          (optionSelected)="selectInstitution($event)"
          [displayWith]="displayInstitutionName"
        >
          <mat-option
            *ngFor="let institution of filteredInstitutions$ | async"
            [value]="institution._id"
          >
            {{ institution.name }}
          </mat-option>
        </mat-autocomplete>
      </mat-form-field>
    </mat-expansion-panel>
  </mat-accordion>
</ng-container>
